local B = BixLib

SLASH_GROWLER1 = "/growler"
SLASH_GROWLER2 = "/growl"
SlashCmdList["GROWLER"] = function(msg)
	if (not msg or msg == "" or msg == "help") then
		print(" ")
		print("Growler slash commands:")
		print("These commands CAN be used in combat:")
		print("        /growl help    -  Shows this list.")
		print("        /growl settings    -  Brings up the settings panel.")
		print("        /growl slashmsg on/off    -  Enables/disables confirmation messages from these commands.")
		print("        /growl sound on/off    -  Enables/disables sounds.")
		print("        /growl remind on/off    -  Keep/stop making sounds when no action is taken.")
		print("        /growl notify on/off    -  Notify group when another player's pet is using growl.")
		print("        /growl screenicons on/off    -  Enable/disable blinking icons at the center of the screen.")
		-- print("        /growl tooltips on/off    -  Enable/disable tooltips.")
		print("        /growl snooze 5-300    -  For how long should alerts be delayed after right-clicking it.")
		print("        /growl growl on/off    -  Enable/disable alert for Growl.")
		print("        /growl call on/off    -  Enable/disable alert for Call Pet.")
		print("        /growl revive on/off    -  Enable/disable alert for Revive Pet.")
		print("        /growl mend on/off    -  Enable/disable alert for Mend Pet.")
		print("        /growl mendat 10-100    -  At how much health% should Growler alert for Mend Pet.")
		print("        /growl playdead on/off    -  Enable/disable alert for Play Dead.")
		print("        /growl wakeup on/off    -  Enable/disable alert for Wake Up.")
		print("        /growl passive on/off    -  Enable/disable alert for putting your pet on passive.")
		print("        /growl assist on/off    -  Enable/disable alert for putting your pet on assist.")
		print(" ")
		print("These commands can NOT be used combat:")
		print("        /growl buttons on/off    -  Enables/disables action buttons.")
		print("        /growl nonparty on/off    -  Enables/disables growl alert when not in a party.")
		print("        /growl petbuttons on/off    -  Shows/hides call/dismiss pet buttons.")
		print("        /growl specbuttons on/off    -  Shows/hides pet respec buttons.")
		print("        /growl petsbottom on/off    -  Displays the call/dismiss pet buttons at the bottom of the bar, rather than at the top.")
		print("        /growl specsbottom on/off    -  Displays the pet respec buttons at the bottom of the bar, rather than at the top.")
		print("        /growl barsize 0.8-2.0    -  Change the size of the bar.")
		print("        /growl savepos on/off    -  Remember where you put the bar.")
		print(" ")
	else
		local option, value = string.match(string.lower(msg),"(%S*)%s*([%S%d%a]+)")
		local number = tonumber(string.match(value,"^(%d+)$"))
		local float = tonumber(string.match(value,"^([%d]+\.[%d]+)$"))
		-- COMBAT
		if (msg == "settings") then
			InterfaceOptionsFrame_OpenToCategory(Growler.Options)
			InterfaceOptionsFrame_OpenToCategory(Growler.Options)
			return
		elseif (msg == "slashmsg on") then
			GrowlerDB.options.slashmsg = true
			if GrowlerDB.options.slashmsg then Growler.msg("Confirmation messages enabled.") end
			return
		elseif (msg == "slashmsg off") then
			GrowlerDB.options.slashmsg = false
			return
		elseif (msg == "sound on") then
			GrowlerDB.options.sound = true
			if GrowlerDB.options.slashmsg then Growler.msg("Sounds enabled.") end
			return
		elseif (msg == "sound off") then
			GrowlerDB.options.sound = false
			if GrowlerDB.options.slashmsg then Growler.msg("Sounds disabled.") end
			return
		elseif (msg == "remind on") then
			GrowlerDB.options.reminder = true
			if GrowlerDB.options.slashmsg then Growler.msg("Now keeps making sounds when no action is taken.") end
			return
		elseif (msg == "remind off") then
			GrowlerDB.options.reminder = true
			if GrowlerDB.options.slashmsg then Growler.msg("Now stops making sounds when no action is taken.") end
			return
		elseif (msg == "notify on") then
			GrowlerDB.options.notifygroup = true
			if GrowlerDB.options.slashmsg then Growler.msg("Now notifies group when another player's pet is using growl.") end
			return
		elseif (msg == "notify off") then
			GrowlerDB.options.notifygroup = false
			if GrowlerDB.options.slashmsg then Growler.msg("Now stops notifying group when another player's pet is using growl.") end
			return
		elseif (msg == "screenicons on") then
			GrowlerDB.options.screenicons = true
			if GrowlerDB.options.slashmsg then Growler.msg("Enabled screen icons.") end
			return
		elseif (msg == "screenicons off") then
			GrowlerDB.options.screenicons = false
			if GrowlerDB.options.slashmsg then Growler.msg("Disabled screen icons.") end
			return
		elseif (msg == "tooltips on") then
			-- GrowlerDB.options.tooltips = true
			-- if GrowlerDB.options.slashmsg then Growler.msg("Tooltips enabled.") end
			return
		elseif (msg == "tooltips off") then
			-- GrowlerDB.options.tooltips = false
			-- if GrowlerDB.options.slashmsg then Growler.msg("Tooltips disabled.") end
			return
		elseif (option == "snooze" and number<301 and number>4) then
			GrowlerDB.options.snooze = number
			if GrowlerDB.options.slashmsg then Growler.msg("Snooze timer set to " .. tostring(number) .. " seconds.") end
			return
		elseif (msg == "growl on") then
			GrowlerDB.options.enable_growl = true
			if GrowlerDB.options.slashmsg then Growler.msg("Alert for Growl enabled.") end
			return
		elseif (msg == "growl off") then
			GrowlerDB.options.enable_growl = false
			if GrowlerDB.options.slashmsg then Growler.msg("Alert for Growl disabled.") end
			return
		elseif (msg == "call on") then
			GrowlerDB.options.enable_growl = true
			if GrowlerDB.options.slashmsg then Growler.msg("Alert for Call Pet enabled.") end
			return
		elseif (msg == "call off") then
			GrowlerDB.options.enable_growl = false
			if GrowlerDB.options.slashmsg then Growler.msg("Alert for Call Pet disabled.") end
			return
		elseif (msg == "revive on") then
			GrowlerDB.options.enable_growl = true
			if GrowlerDB.options.slashmsg then Growler.msg("Alert for Revive Pet enabled.") end
			return
		elseif (msg == "revive off") then
			GrowlerDB.options.enable_growl = false
			if GrowlerDB.options.slashmsg then Growler.msg("Alert for Revive Pet disabled.") end
			return
		elseif (msg == "mend on") then
			GrowlerDB.options.enable_growl = true
			if GrowlerDB.options.slashmsg then Growler.msg("Alert for Mend Pet enabled.") end
			return
		elseif (msg == "mend off") then
			GrowlerDB.options.enable_growl = false
			if GrowlerDB.options.slashmsg then Growler.msg("Alert for Mend Pet disabled.") end
			return
		elseif (option == "mendat" and number<101 and number >9) then
			GrowlerDB.options.mend_threshhold = number/100
			if GrowlerDB.options.slashmsg then Growler.msg("Mend will now alert when your pet is below " .. number .. "% health.") end
			return
		elseif (msg == "playdead on") then
			GrowlerDB.options.enable_growl = true
			if GrowlerDB.options.slashmsg then Growler.msg("Alert for Play Dead enabled.") end
			return
		elseif (msg == "playdead off") then
			GrowlerDB.options.enable_growl = false
			if GrowlerDB.options.slashmsg then Growler.msg("Alert for Play Dead disabled.") end
			return
		elseif (msg == "wakeup on") then
			GrowlerDB.options.enable_growl = true
			if GrowlerDB.options.slashmsg then Growler.msg("Alert for Wake Up enabled.") end
			return
		elseif (msg == "wakeup off") then
			GrowlerDB.options.enable_growl = false
			if GrowlerDB.options.slashmsg then Growler.msg("Alert for Wake Up disabled.") end
			return
		elseif (msg == "passive on") then
			GrowlerDB.options.enable_growl = true
			if GrowlerDB.options.slashmsg then Growler.msg("Alert for putting your pet on passive enabled.") end
			return
		elseif (msg == "passive off") then
			GrowlerDB.options.enable_growl = false
			if GrowlerDB.options.slashmsg then Growler.msg("Alert for putting your pet on passive disabled.") end
			return
		elseif (msg == "assist on") then
			GrowlerDB.options.enable_growl = true
			if GrowlerDB.options.slashmsg then Growler.msg("Alert for putting your pet on assist enabled.") end
			return
		elseif (msg == "assist off") then
			GrowlerDB.options.enable_growl = false
			if GrowlerDB.options.slashmsg then Growler.msg("Alert for putting your pet on assist disabled.") end
			return
		end
		-- NO COMBAT
		if not InCombatLockdown() then
			if (msg == "buttons on") then
				GrowlerDB.options.enable = true
				if GrowlerDB.options.slashmsg then Growler.msg("Buttons enabled.") end
			elseif (msg == "buttons off") then
				GrowlerDB.options.enable = false
				if GrowlerDB.options.slashmsg then Growler.msg("Buttons disabled.") end
			elseif (msg == "nonparty on") then
				GrowlerDB.options.nonparty = true
				if GrowlerDB.options.slashmsg then Growler.msg("Enabled growl alert when not in a party.") end
			elseif (msg == "nonparty off") then
				GrowlerDB.options.nonparty = false
				if GrowlerDB.options.slashmsg then Growler.msg("Disabled growl alert when not in a party.") end
			elseif (msg == "petbuttons on") then
				GrowlerDB.options.showpets = true
				if GrowlerDB.options.slashmsg then Growler.msg("Now showing call/dismiss pet buttons.") end
			elseif (msg == "petbuttons off") then
				GrowlerDB.options.showpets = false
				if GrowlerDB.options.slashmsg then Growler.msg("Now hiding call/dismiss pet buttons.") end
			elseif (msg == "petsbottom on") then
				GrowlerDB.options.petsbottom = true
				if GrowlerDB.options.slashmsg then Growler.msg("Now displaying the call/dismiss pet buttons at the bottom of the bar.") end
			elseif (msg == "petsbottom off") then
				GrowlerDB.options.petsbottom = false
				if GrowlerDB.options.slashmsg then Growler.msg("Now displaying the call/dismiss pet buttons at the top of the bar.") end
			elseif (msg == "specsbottom on") then
				GrowlerDB.options.specsbottom = true
				if GrowlerDB.options.slashmsg then Growler.msg("Now displaying the pet respec buttons at the bottom of the bar.") end
			elseif (msg == "specsbottom off") then
				GrowlerDB.options.specsbottom = false
				if GrowlerDB.options.slashmsg then Growler.msg("Now displaying the pet respec buttons at the top of the bar.") end
			elseif (option == "barsize" and float<2.0 and float >=0.8) then
				GrowlerDB.options.barsize = float
				if GrowlerDB.options.slashmsg then Growler.msg("Bar size changed.") end
			elseif (msg == "savepos on") then
				GrowlerDB.options.savepos = true
				if GrowlerDB.options.slashmsg then Growler.msg("Bar position will now be saved.") end
			elseif (msg == "savepos off") then
				GrowlerDB.options.savepos = false
				if GrowlerDB.options.slashmsg then Growler.msg("Bar position will now not be saved.") end
			end
			Growler.bar.ResetPos()
		else
			Growler.msg("You cannot change that setting in combat.",true)
		end
	end
end